 Sub : WWIV MODNET
80/99: EDO012.422 - Directory listing in a box.
 Name: Ed O'Brien #1 @16968
 Date: Wednesday, February 10, 1993   5:30 pm {PST}
 From: Data Xfer BBS [ASV] WWIVnet (S. California) [619-441-0183]


Ŀ
 Mod Name: EDO012.422                    Mod Author: Ed O'Brien             
 Difficulty: Mostly block read           Date: 01/29/93                     
 WWIV Version: WWIV422+                                                     
 Description: Directory Listing in a box. When user hits '*' at transfer    
              menu, the directory listing will be in a box.                 


This mod will also indicate which Directory the user is currently in by
highlighting the current directory in "white on a blue" background and
indicate total files in each directory and display NEW files since their
last logon.  This listing compliments my EDO010.422 mod in that both look
and respond in the same manner.

STEP 1: Back up your source.

STEP 2: Load up BBS.C and remove "void dirlist(void)". It needs to be moved to
        XFER.C for this to function properly.

STEP 3: Save BBS.C and load up XFER.C and at the very end of XFER.C add the
        following: 



void dirlist(void)
/* Add entire void */
{
  int i,abort,i1,sam,tally, i2;
  char s[130],s1[6];
  uploadsrec u;

  abort=0;
  nl();
  pla(get_string(981),&abort);         /* see NOTE 1 */
  nl();
  pla(get_string(980),&abort);         /* see NOTE 2 */
  ansic(7);
    if (okansi()) {
      
npr("ͻ\r\n",&abort);
    } else
      
npr("+----+-----+------------------------------------------+------+------+\r\n",&abort);
  i=0;
  while ((i<num_dirs) && (udir[i].subnum!=-1) && (!abort)) {
    dliscan1(udir[i].subnum);
    i1=udir[i].subnum;
    if (qsc_n[i1/32]&(1L<<(i1%32)))
      i2=1;
    else
      i2=0;
  if (i2) strcpy(s1," * ");
 else
  strcpy(s1," ");
    if (dlf<0) {
        npr("Error reading data file!\r\n");
        closedl();
        return;
    }
    sam=1;
    for (i1=1; i1<=numf; i1++) {
        SETREC(i1);
        read(dlf,(void *)&u,sizeof(uploadsrec));
        if (u.daten>=nscandate)
            sam++;
    }
    sam-=1;
    if (okansi()) {
      if (udir[curdir].keys==udir[i].keys)
        sprintf(s," %2s  %3s  %-40.40s  %4d  %4d ",
            udir[i].keys, s1, directories[udir[i].subnum].name,sam,numf);
      else
        sprintf(s," %2s  %3s  %-40.40s  %4d  %4d ",
            udir[i].keys, s1, directories[udir[i].subnum].name,sam,numf);
     } else {
       if (udir[curdir].keys==udir[i].keys)
         sprintf(s,"| %2s | %3s | %-40.40s | %4d | %4d |<-",
           udir[i].keys, s1, directories[udir[i].subnum].name,sam,numf);
       else
         sprintf(s,"| %2s | %3s | %-40.40s | %4d | %4d |",
            udir[i].keys, s1, directories[udir[i].subnum].name,sam,numf);
     }
    pla(s,&abort);
    i++;
    closedl();
  }
  ansic(7);
  if (okansi()) {
    
npr("ͼ\r\n");
  } else
    
npr("+----+-----+------------------------------------------+------+------+\r\n");
  if (i==0)
    pla("None.",&abort);
}


STEP 4: Save XFER.C

STEP 5: Drop to the DOS prompt and type "make fcns" to update FCNS.H to
        reflect the changes.  Or you can make the changes to FCNS.H manually.

STEP 6: Type "make" and recompile BBS.EXE.

STEP 7: You will need to update your get_string files to include the 2 strings
        above.  Since mine are probably different from yours I am giving them
        to you in the NOTE's below.  Change the numbers to whatever you need!

NOTE 1:             * Indicates Directory is in your Q-Scan!

NOTE 2:  Num   Scn   Directory Title                            New   Total
          ^    ^     ^                           ^                    ^
          |    |     |_3 spaces                  |_28 spaces          |_3 
spaces
          |    |_3 spaces
          |_ 1 space

You may have to diddle the spacing a bit to make it all line up but the above
is pretty close.

I can be reached at:
Ed O'Brien
1@16968 WWIVnet
1@6951  IceNET

