Ŀ
 Mod Name      : JAFO02B.MOD               Mod Author: JAFO 1@1    TerraNET 
 Difficulty    : ۱                                 1@8857 IceNET   
 WWIV Version  : 4.22                                       1@8861 WWIVnet  
 Mod Date      : 01/30/93                                                   
 Files Affected: MSGBASE1.C, UTILITY.C, FCNS.H                              
 Description   : Display Authors in Message Title Scan                      


[ Description ]

This mod will display message authors next to message titles in a title
scan.  I've seen a similar mod by ShadowSpawn, but his only displays the
user's number, without the name.  This mod makes it easier to tell who
posted what.  Here is an example:

 (41) ...                                      [John Doe]
 [42] Well...                                  [JAFO]
 (43) Yeah, but don't you think...             [Johnny Carson]
*(44) Haha                                     [Boogeyman]
*<45> Hmm...                                   [#11 @8854]
*(46) I think                                  [UNKNOWN]

[ Legend ]

  =  Existing line - Do not change
  +  Add this line
  -  Remove this line
  %  Change this line

[ Step 1 ]

Please back up your source code.  Even the best programmers make mistakes.

[ Step 2 ]

In MSGBASE1.C, and change the lines shown in "void scan".

= void scan(int msgnum, int optype, int *nextsub)
= {
%   char s[81],s1[81],s2[81],s3[81],*b,*ss1;
=   int i,i1,i2,done,quit,abort,next,val,realexpress;
=   slrec ss;
=   long l,len;
=   postrec p,p1;
+   userrec u;

[ Step 3 ]

Now search for "case 1: /* List Titles */", and either replace it with the
one below, or do the indicated changes yourself.

=      case 1: /* List Titles */
=        i=0;
=        abort=0;
=        if (msgnum>=nummsgs)
=          abort=1;
=        while ((!abort) && (!hangup) && (++i<=10)) {
=          ++msgnum;
=          if ((msgs[msgnum].ownersys==0) && (msgs[msgnum].owneruser==usernum))
=            sprintf(s1,"[%d]",msgnum);
=          else if (msgs[msgnum].ownersys!=0)
=            sprintf(s1,"<%d>",msgnum);
=          else
=            sprintf(s1,"(%d)",msgnum);
=          for (i1=0; i1<5; i1++)
=            s[i1]=32;
=          if (msgs[msgnum].qscan>qsc_p[curlsub])
=            s[0]='*';
=          if (msgs[msgnum].status & (status_pending_net | status_unvalidated))
=            s[0]='-';
%          strcpy(&s[5-strlen(s1)],s1);
=          strcat(s," ");
=          if 
((msgs[msgnum].status&(status_unvalidated|status_delete))&&(!lcs()))
%            strcpy(s1,get_string(665));
=          else
%            strcpy(s1,msgs[msgnum].title);
+          ss=syscfg.sl[thisuser.sl];
+          if ((msgs[msgnum].anony & anony_sender) &&
+             (!(ss.ability & ability_read_post_anony)))
+            sprintf(s2,"%-40.40s [UNKNOWN]",s1);
+          else
+            if (msgs[msgnum].ownersys==0) {
+              read_user(msgs[msgnum].owneruser,&u);
+              strcpy(s3,nam2(&u));
+              s3[30]=0;
+              sprintf(s2,"%-40.40s [%s]",s1,s3);
+            } else
+              if (net_num_max>1) {
+                strcpy(s3,net_name);
+                s3[13]=0;
+                sprintf(s2,"%-40.40s [#%d @%d - %s]",s1,
+                        msgs[msgnum].owneruser,
+                        msgs[msgnum].ownersys,s3);
+              } else
+                sprintf(s2,"%-40.40s [#%d @%d]",s1,msgs[msgnum].owneruser,
+                        msgs[msgnum].ownersys);
+          strcat(s,s2);
=          pla(s,&abort);
=          if (msgnum>=nummsgs)
=            abort=1;
=        }
=        optype=0;
=        break;

[ Step 4 ]

In UTILITY.C, add the following function right after "char *nam1".

char *nam2(userrec *u1)
{
  static char o[81];
  int f,p;
  userrec u;

  u=*u1;
  f=1;
  for (p=0; p<strlen(u.name); p++) {
    if (f) {
      if ((u.name[p]>='A') && (u.name[p]<='Z'))
        f=0;
      o[p]=u.name[p];
    } else {
      if ((u.name[p]>='A') && (u.name[p]<='Z'))
        o[p]=u.name[p]-'A'+'a';
      else {
        if ((u.name[p]>=' ') && (u.name[p]<='/'))
          f=1;
        o[p]=u.name[p];
      }
    }
  }
  o[p]=0;
  return(o);
}

[ Step 5 ]

In FCNS.H, add the following line.

= char *nam(userrec *u1, unsigned int un);
= char *nam1(userrec *u1, unsigned int un, unsigned int sy);
+ char *nam2(userrec *u1);
= double nsl();
= char *date();

[ Step 6 ]

That's it!  Re-compile, and you'll always know who posted what!

[ Disclaimer ]

Don't complain to me if your board gets fried, your hard disk goes nuts, or
something terrible happens.  The code in this mod should be harmless, but I
can't guarantee it will work for you.  It works on my board.

JAFO 1@1    (TerraNET)
     1@8857 (IceNET)
     1@8861 (WWIVnet)



