Filoheader(c)Ŀ
 Mod Name:       WAF016A.MOD             Author:  Wafwot #2 @2632           
 Difficulty:     Easy/Medium             Date:    Feb 8, 1993               
 Files Affected: VARS.H, FCNS.H, NEWUSER.C, MSGBASE.C                       
 WWIV Version:   4.22 Tested, should work with future versions.             
 Description:    Sends email to a newuser from the sysop.  This sends the   
                 newuser email, using a file in Gfiles.  Nice feature!      


More Descriptive:
~~~~~~~~~~~~~~~~~
Ok, I have logged on to other BBS' in the country (not WWIV) and when I have
completed the newuser logon procedure, it tells me I have mail.  I'm not
sure, but I think (vbbs) has this feature.  This mail tells me about the
sysop, some features of the BBS, and/or other tidbits of useless <grin>
information about the BBS.  It makes some of the less experienced users
jump for joy, because they have mail on their first call... and you know
how new users love to get mail!

This version was modded to work for 4.22, since it was so graciously
nominated as mod-of-the-month in the last issue of WWIVnews (Nov/Dec/Jan).
Thanks to everyone at WWIVnews and Filo, it was a total surprise!  :)
There were a number of changes.  Two of note were the external strings,
and the other being an added variable to sendout_email for net numbers.

Anyway, here it is.  I have no idea if this has been done before, but I'd
like to think it was my idea.  I have over 900 mods, dating back to 1988.
This is the beginning and end of the directroy, sorted on date:

 Volume in drive E is MS_DOS_5
 Volume Serial Number is 198C-1009
 Directory E:\MODS

SALT     MOD      7253 07-12-88   6:25a
NETNAME  MOD      4537 09-10-88  11:06a
LOTTERY  MOD      1139 09-25-88   1:13p
.
.
.
CBVOFF   MOD      7776 02-09-93   5:09p
TAG422   MOD     86673 02-10-93   7:38a
WAF016   MOD     13076 02-11-93  11:54p
      928 file(s)    5784155 bytes
                   114540544 bytes free

(Geez, Wasn't Wayne's board called SALT BBS at one time?)

In those 928 mods, I've never seen ANYTHING like this.  If it is someone
else's idea, tough shit.  I didn't steal it from you.  <grin>

Ok, Let go...


Step 1:
~~~~~~~
Backup.


Step 2:
~~~~~~~
Load up VARS.H and add the 'echo_off' variable to the variable list.  Just
add the 'echo_off' variable.  The 'echo_off' variable is used so that when
you send the newuser email automatically, the user does not see all the
lines associated with sending a load file via email.  ie, File loaded into
workspace, Saving...Mail sent to User #0, etc.  It makes it seemless and
invisible.

              screenlen, screenlinest, smwcheck, statusfile,
              sysop_alert, tempio, topdata, topline, two_color,
              userfile, usernum, useron, use_workspace, using_modem,
              wfc, x_only, echo_off;
                          /* ^ ADD THIS */

__EXTRN__ unsigned short com_speed, *csn_index, crc, *gat, modem_flag,
                         modem_mode, modem_speed, net_sysnum;


Step 3:
~~~~~~~
Save VARS.H and load up NEWUSER.C.  This is the actual void that sends
the email.  Block copy the whole void to the end of your NEWUSER.C file.

void newuser_mail(void)
{
  char title[61],s[81],mail[81];
  messagerec msg;

  echo_off=0;                                      /* turns 'echo_off' */
  title[0]=0;                                      /* clears the title */
  strcpy(s,nam(&thisuser,usernum));                /* copy username to s */
  sprintf(mail,"%sNEWFORM.MSG",syscfg.gfilesdir);  /* finds the form ltr */
  load_workspace(mail,1);                          /* loads form ltr */
  msg.storage_type=2;                              /* set mail storage */
  inmsg(&msg,title,0,0,"EMAIL",0,s,0);             /* places ltr in mail */
  sendout_email(title,&msg,0,usernum,0,1,1,0,0,0); /* sends email */
  ++thisuser.waiting;                              /* so newuser can read it */
  echo_off=1;                                      /* turns echo back on */
}


Step 4:
~~~~~~~
This is where we will call the newuser_mail void.  In NEWUSER.C, this is
between where the user pressed 'Q' to continue after he filled in all of
his information, and before they have to re-enter their password.  I
liked it here because sending the mail will take a some (not much) time,
and it DOES say 'Please wait...' while the BBS assigns a user number.  This
was just the obvious place.

    ok=0;
    newuser_mail();                             /* ADD ME */
    topscreen();
    do {
      nl();
      nl();
      outstr(get_string(591)); pln(usernum);
      outstr(get_string(592)); pl(thisuser.pw);


Step 5:
~~~~~~~
Since we added a new void to NEWUSER.C, load up FCNS.H and add the new
prototype to the newuser.c section.

void input_comptype(void);
void input_screensize(void);
void newuser_mail(void);                        /* ADD ME */
void input_pw(void);
void input_ansistat(void);


Step 6:
~~~~~~~
Save FCNS.H (and NEWUSER.C if you didn't already), and load up MSGBASE.C.
Search for void load_workspace(blahblah) and make the following changes.
Again, this is making it so the newuser DOES NOT see the printed lines
associated with sending mail.  Make the marked lines look like what is
below.  I indented my lines, because I like to be neat.  <grin>

  else
    use_workspace=0;
  nl();
  if (echo_off) {                                             /* ADD */
    pl(get_string(624));                                      /* INDENT */
    nl();                                                     /* INDENT */
    if (!use_workspace)                                       /* INDENT */
      pl(get_string(625));                                    /* INDENT */
  }                                                           /* ADD */
}


Step 7:
~~~~~~~
Now, still in MSGBASE.C, find void inmsg(blahblah) and make the following
changes.  Again, all we are doing is adding if statements to avoid printing
lines that we DON'T want printed with the newuser_mail.  First, find the
section of code that deals with entering a title.  You can just block copy
what I have here, or you can make the changes.

  if (echo_off) {                                               /* ADD ME */
    nl();
    helpl=6;
    if (okansi()) {
      prt(2,get_string(326));
      mpl(60);
      inputl(title,60);
    } else {
      pl(get_string(626));
      outstr(get_string(326));
      inputl(title,60);
    }
  }                                                             /* ADD ME */

Then directly under this section of code, add this if statement.  This is
making a personalized title.  A nice touch, if I don't say so myself.

  if (!echo_off) {
    sprintf(title,"WELCOME %s!",thisuser.name);
  }


Step 8:
~~~~~~~
Further down in void inmsg(blahblah) in MSGBASE.C, find this section of
code and make the indicated changes/additions.

      save=exist(fnx);
      if (save) || (echo_off) {                                 /* CHANGE */
        pl(get_string(639));
      }
      use_workspace=0;


Step 9:
~~~~~~~
Still further down, find this code, and make THESE changes.

      case anony_real_name:
        real_name=1;
        *anony=0;
        break;
    }
    if (echo_off) {                                             /* ADD ME */
      outstr(get_string(91));                                   /* INDENT */
    }                                                           /* ADD ME */
    if (fsed) {
      i5=open(fnx,O_RDONLY | O_BINARY);
      l1=filelength(i5);
    } else {


Step 10:
~~~~~~~~
And again.... in void sendout_email(blahblah), find this code, and make the
indicated changes.

    farfree(b);
    farfree(b1);
  }
  s2[0]=0;
  if (echo_off) {                                               /* ADD ME */
    strcpy(s,get_string(647));                                  /* INDENT */
  }                                                             /* ADD ME */
  if (sy==0) {
    read_user(un,&ur);
    ++ur.waiting;
    write_user(un,&ur);


Step 11:
~~~~~~~
And now.... at the very bottom of void sendout_email, make this indicated
change.

  save_status();
  if (!wfc)
    topscreen();
  if (echo_off)                                                 /* ADD ME */
    pl(s);                                                      /* INDENT */
  if (s2[0])
    pl(s2);
}

I know I didn't need some of those brackets, but I may add some stuff later,
and they don't seem to effect anything.


Step 12:
~~~~~~~~
Ok, now just in case the newuser gets dumped off line, or they hangup on
you in the middle of getting sent email from the newuser_mail void, we will
add the following line to LILO.C so that the echo_off variable equals 1.
'echo_off' must ALWAYS equal 1 except when sending a newuser mail from this
mod.  If echo_off equals 0, then your regular, registered user will not see
the 'Saving...Mail sent to Jest #1' lines that they normally do.  This
will force echo_off to be 1 for EVERY caller.  In void getuser(void),
near the top, add this one line.

  ok=0;
  checkit=1;
  okmacro=0;
  echo_off=1;                                                   /* ADD ME */
  actsl=syscfg.newusersl;
  if ((!net_only) && (incom)) {
    sprintf(s,"%sWELCOME.ANS",syscfg.gfilesdir);
    if (exist(s)) {
      nl();
#ifdef OLD


Step 13:
~~~~~~~~
And again, just for safety, add this one line in XINIT.C.  This will make
echo_off equal 1 whenever the BBS is loaded up.  In void init(void) in
XINIT.C find this code and add the indicated line.

#ifdef EMS_XMS
  if (_OvrInitEms(0,0,16)!=0)
    _OvrInitExt(0L,0);
#endif

  userfile=-1;
  configfile=-1;
  statusfile=-1;
  dlf=-1;
  curlsub=-1;
  curldir=-1;
  echo_off=1;                                                   /* ADD ME */
  setvect(save_dos, getvect(INT_REAL_DOS));
  oldx=0;


Step 14:
~~~~~~~~
That should do it.  Save all files and compile/link.  You will compile the
whole BBS, since we added a variable to VARS.H.

Step 15:
~~~~~~~~
You need to create a NEWFORM.MSG file.  This is the file that is sent to
the newuser.  I have installed an MCI mod into our BBS, so mine is kinda
full of MCI commands that place the newuser's name, and other info into
the mail.  It really looks nice when a newuser logs on, and they get
mail that looks as though the sysop wrote it to them!  I recommend a
good MCI mod to go along with this mod.  Below is my NEWFORM.MSG.  You
can use it, or create your own. (I removed the MCI codes from it, and
changed it around for one sysop... The Evening Post has two.)
______________________________________________

Welcome to The Evening Post!

You have successfully logged onto one of Whidbey Island's most exciting
bulletin boards.  Thanks for calling!

As you can see, The Evening Post is setup to automatically send you
email.  You should respond to this mail, by pressing 'A' at the
email prompt (Mail {?}).

With most prompts, pressing a '?' will get you help.  You will be
presented with a menu of available commands for the prompt.  It's
really quite simple.  If you do have trouble, press and hold the
control key (Ctrl) while pressing the letter 'O' key. (CTRL-O).
This will give you context-sensitive help throughout the BBS, any-
where you may be.

If you want to change any features of your new account, just press 'D'
to go to D:efaults.  Here, you can change just about anything
pertaining to your account.

You now have full access to all of the BBS's message subs, file areas,
and external games.  I am always adding new stuff to the BBS, so
call often!

If you have any questions, please press 'F' and send feedback to me.
I will be sure to answer it.  I like hearing from all my users!

If you think I can improve the BBS, please let me know how, and I will
try to implement your suggestions.

Enjoy your visit, and call back often, you're always welcome!
_____________________________________

Try to keep it short.  Too long, and the user gets bored.  If you use this
mod, PLEASE, PLEASE, PLEASE send me email.  I'd like to know what you
think even if you hate it....  Wafwot #2 @2632.


Other WAFWOT mods:
~~~~~~~~~~~~~~~~~~
I'll email one of these to anyone who wants them.

WAF001  .MOD  -   A different LOGON.ANS for each day of the week.
WAF002  .MOD  -   Takes a password from a file - No more X8T12J.
WAF003  .MOD  -   Select a sysop for chatting. NICE windows...
WAF004  .MOD  -   Default selectable Animated pause.
WAF005B .MOD  -   'A' reply to email, send to another instead of sender.
WAF006  .MOD  -   Select a sub by pressing '#'
WAF007  .MOD  -   Fixes for the closed mailbox.  4.21+.
WAF008D .MOD  -   REMOVED FROM CIRCULATION...REWORKING.
WAF009  .MOD  -   Send short msgs over net.  Multi-net/4.21a compatible.
WAF010  .MOD  -   Make the BBSLIST.MSG downloadable.  4.21+
WAF011B .MOD  -   A small, simple mod to wish a user Happy Birthday.  4.21+
WAF012  .MOD  -   Clear the screen between each msg read.
WAF013  .MOD  -   Msg Cmnd Menu when RETURN is hit twice in the editor. 4.21a
WAF014  .MOD  -   A void for multiple CR/LF. No more nl(); nl(); nl(); 4.21a
WAF015A .MOD  -   Colorize text in any ansi color. Non-ansi compat. 4.21a
WAF016A .MOD  -   Sends email automatically to newuser on 1st call. 4.21a


W-hat
A
F-u@king
W-aste
O-f
T-ime

The Evening Post BBS @2632

